#define _GNU_SOURCE

#include <stdio.h>
#include <libgen.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#define SBOX_ALIEN_TOOL_DIR "SBOX_ALIEN_TOOL_DIR"
#define DEFAULT_SBOX_ALIEN_TOOL_DIR "/scratchbox/alien_tools/bin"

extern char **environ;
extern int errno;

int main(int argc, char **argv)
{
	char *tool_dir;
	char *exe;
	char *binaryname;
	char **my_argv;
	int i=0,j=0;

	if (!(tool_dir = getenv(SBOX_ALIEN_TOOL_DIR))) {
		tool_dir = DEFAULT_SBOX_ALIEN_TOOL_DIR;
	}

	binaryname = basename(strdup(argv[0]));

	exe = malloc(strlen(tool_dir) + strlen(binaryname) + 2);
	exe[0] = '\0';
	strcat(exe,tool_dir);
	strcat(exe, "/");
	strcat(exe,binaryname);
	
	my_argv = malloc((argc + 4)*sizeof(char **));
	my_argv[i++] = "/scratchbox/host_shared/lib/ld-linux.so.2";
	my_argv[i++] = "--library-path";
	my_argv[i++] = "/scratchbox/host_shared/lib/";
	my_argv[i++] = exe;

	for (j=1; j < argc; i++,j++) { // argv[argc] == NULL
		my_argv[i] = argv[j];
	}
	my_argv[i] = NULL;
	
	if (execve("/scratchbox/host_shared/lib/ld-linux.so.2", my_argv, environ) < 0) {
		fprintf(stderr, "Error executing scratchbox tool binary(%i): '%s': ", errno, exe);
		perror("");
		return(1);
	}
	return(2);
}
